#include <iostream>
#include <vector>
#include <map>
#include <cstring>
using namespace std;

const int MAXN = 100005;
const int MAXM = 300005;
const int MAXD = 12;
const int LOGN = 20;
const int MOD = 1000000007;

int n, m;
vector<int> g[MAXN];
pair<int, int> ab[MAXM];

int lev[MAXN], st[MAXN][LOGN];
vector<pair<int, int>> dep[MAXN];
int mat[MAXD];
long long dp[1 << MAXD];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 1; i <= m; ++ i)
    {
        cin >> ab[i].first >> ab[i].second;
    }
}

void DFS(int u = 1)
{
    for (int i = 1; i < LOGN; ++ i)
    {
        int hp = st[u][i - 1];
        if (hp == -1) st[u][i] = -1;
        else st[u][i] = st[hp][i - 1];
    }

    for (int v : g[u])
    {
        if (st[v][0] == 0)
        {
            st[v][0] = u;
            lev[v] = lev[u] + 1;
            DFS(v);
        }
    }
}

void query(int a, int b)
{
    bool swapped = false;
    if (lev[a] < lev[b])
    {
        swap(a, b);
        swapped = true;
    }
    for (int i = LOGN - 1; i >= 0; -- i)
    {
        if (lev[a] - (1 << i) >= lev[b]) a = st[a][i];
    }
    if (swapped) swap(a, b);

    if (a == b)
    {
        if (!swapped) // impossible
        {
            cout << 0 << endl;
            exit(0);
        }
        else return; // always true
    }

    for (int i = LOGN - 1; i >= 0; -- i)
    {
        if (st[a][i] != st[b][i])
        {
            a = st[a][i];
            b = st[b][i];
        }
    }

    int p = st[a][0];
    dep[p].emplace_back(a, b);
}

int Solve(int u)
{
    memset(mat, 0, 4 * MAXD);
    map<int, int> c;
    for (int i = 0; i < g[u].size(); ++ i)
    {
        int v = g[u][i];
        if (v != st[u][0]) c[v] = c.size();
    }

    for (int i = 0; i < dep[u].size(); ++ i)
    {
        mat[c[dep[u][i].second]] |= 1 << c[dep[u][i].first];
    }

    // transitive closure
    for (int k = 0; k < c.size(); ++ k)
    {
        for (int i = 0; i < c.size(); ++ i)
        {
            for (int j = 0; j < c.size(); ++ j)
            {
                if ((mat[k] & (1 << i)) != 0 && (mat[j] & (1 << k)) != 0) mat[j] |= 1 << i;
            }
        }
    }

    memset(dp, 0, 1 << (MAXD + 3));
    dp[0] = 1;

    int states = 1 << c.size();
    for (int mask = 1; mask < states; ++ mask)
    {
        for (int i = 0; i < c.size(); ++ i)
        {
            if ((mask & (1 << i)) != 0 && (mat[i] & mask) == 0)
            {
                dp[mask] += dp[mask ^ (1 << i)];
            }
        }
    }

    return dp[states - 1];
}

int main()
{
    Init();

    st[1][0] = -1;
    lev[1] = 0;
    DFS();

    for (int i = 1; i <= m; ++ i)
    {
        query(ab[i].first, ab[i].second);
    }

    long long ans = 1;
    for (int i = 1; i <= n; ++ i)
    {
        ans = (ans * Solve(i)) % MOD;
    }

    cout << ans << endl;

    return 0;
}
